package net.lecnam.info.channel;

import java.io.IOException;
import java.io.ObjectInput;

public class RemoteObjectReader<A> implements ObjectReader<A> {

	ObjectInput in;
	
	public RemoteObjectReader(ObjectInput in) {
		this.in = in;
	}

	@Override
	@SuppressWarnings("unchecked")
	public A readObject() throws IOException {
		try {
			return (A)in.readObject();
		} catch (ClassNotFoundException e) {
			throw new IOException(e);
		}
	}

}
