package net.lecnam.info.ex3;

import java.io.IOException;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;

import net.lecnam.info.channel.LocalObjectReader;
import net.lecnam.info.channel.LocalObjectWriter;
import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;

public class Main {

	public static void main(String[] args) throws IOException {

	    BlockingQueue<?> bqcs = new LinkedBlockingQueue<>();
	    BlockingQueue<?> bqsc = new LinkedBlockingQueue<>();

		ObjectWriter<?> ows = new LocalObjectWriter<>(bqsc);
		ObjectReader<?> ors = new LocalObjectReader<>(bqcs);

		ComputeEngine<?> server = new ComputeEngine<>(ors, ows);

		ObjectWriter<?> owc = new LocalObjectWriter<>(bqcs);
		ObjectReader<?> orc = new LocalObjectReader<>(bqsc);

		Client client = new Client(orc, owc);

	    Thread tc = new Thread(client);
	    Thread ts = new Thread(server);

	    tc.start();
	    ts.start();

	}

}
